$MOD51
$TITLE(BYTE SIGNED MULTIPLY)
$PAGEWIDTH(132)
$DEBUG
$OBJECT
$NOPAGING

ORG 50H

;-------------Deklarace adresoveho prostoru--------------
;----CHODI----

	vvys	equ	24H		;pomocny byte pro subrutinu deleni
	vys	equ	25H		;nejvyssi byte delence
	str	equ	26H		;stredni  --//--
	niz	equ	27H		;nizsi --//--
	nejniz	equ	28H		;nejnizsi  --//--
	vys_1	equ	29H		;vyssi byte delitele
	str_1	equ	2AH		;stredni byte delitele
	niz_1	equ	2BH		;nizsi    --//--
	schov_1	equ	2CH		;odlozeni mezivysledku 1.byte
	schov_2	equ	2DH		;       --//--	2.byte
	schov_3	equ	2EH		;      --//--   3.byte
	schov_4	equ	2FH		;	--//--  4.byte
	schov_5	equ	30H		;	--//--	5.byte
	pocpos	equ 	31H		;pocet posuvu v rutine deleni
	uprav_bit	bit	0AH	;pomocny bit pro test vynulovani nejvyssiho bytu vysledku

;--------------------Subrutina deleni 4 bytoveho cisla 3 bytovym-----
;Rutina vydeli 4 bytove cislo ulozene v bytech vys=nejvyssi byte,str=stredni byte,niz=nizsi byte a nejniz=nejnizsi byte
;3 bytovym cislem ulozenym v bytech vys_1=vyssi,str_1=stredni a niz_1=nizsi
;vysledek je v bytech nejniz,niz,ev.str,+zbytek vys,nejvys


deleni:	CLR uprav_bit		;nuluj bit - presunout do inicializacni sekvence 
	MOV vvys,#0H		;nuluj pomocny byte delence
	MOV A,vys_1		;nacti vyssi byte delitele
	JNZ pokr_37		;pokud je nulovy,testuj ....
	MOV A,str_1		;obsah stredniho bytu na nulovost - pokud neni nula,zadej po skoku parametry deleni
	JNZ pokr_37		;pokud je nulovy,testuj nejnizsi byte na nulovost
	MOV A,niz_1
	JNZ pokr_38		;pokud je i tento byte nulovy nuluj cely vysledek a odchod z rutimy
	MOV nejniz,#0H		;pokud neni nula,zadej nove parametry deleni
	MOV niz,#0H
	MOV str,#0H
	RET


;parametry deleni 3 (resp. 1bytovym) cislem (pr. 00 00 0AH) pocet posuvu je 3*8 byte
;a je treba prohodit byty niz_1 a str_1 (str_1 = 00H)

pokr_38:MOV pocpos,#18H	;zadej pocet posuvu	
	MOV str_1,niz_1
	MOV niz_1,#0H
	SJMP znovu

;parametry deleni 3 (resp. 3 a 2bytovym) cislem (pr. 22 22 22H,00 22 22H) pocet posuvu je 
;2*8 byte,pozice zustavaji stejne,nastaven bit pro vynulovani nejvyssiho bytu vysledku(str)
;kde se nachazel zbytek

pokr_37:MOV pocpos,#10H
	SETB uprav_bit
znovu:	CLR C		;nuluj CY pred rotaci
	LCALL rot	;rotuj 3 byte a vynuluj nejnizsi
	LCALL uloz	;pred odectem uloz vysledek rotace
	CLR C		;nuluj CY pred odectem
	LCALL odecet	;odecti od byte vys,str,niz byte vys_1,niz_1
	JNC pokr_30	;pokud neni CY skoc
	LCALL zpet	;pokud je CY pak vrat obsah do stavu pred odectem
test_10:DJNZ pocpos,znovu	;sniz pocet posuvu a zacni znovu
	SJMP test_11	;pokud byl plny pocet obehu skonci
pokr_30:MOV A,nejniz
	INC A
	MOV nejniz,A
	SJMP test_10	;skok na test posuvu
test_11:JNB uprav_bit,konec
	MOV str,#0H
konec:	RET

;------------------Rutiny----------------------------------


;Rutina  "uloz" - uschova vys_1,str_1 a niz_1 do schov_1,schov_2 a schov_3

uloz:	MOV schov_1,vvys
	MOV schov_2,vys
	MOV schov_3,str
	MOV schov_4,niz
	MOV schov_5,nejniz
	RET
;----------------------------------------------------------

;Rutina "rot" - rotuje pres CY 4 byte
rot:	MOV A,nejniz
	RLC A
	MOV nejniz,A
	MOV A,niz	;nacti obsah niz
	RLC A		;rotuj doleva niz pres CY
	MOV niz,A	;uloz vysledek
	MOV A,str	;nacti str
	RLC A		;rotuj A
	MOV str,A	;uloz vysledek
	MOV A,vys	;nacti vys
	RLC A		;rotuj A
	MOV vys,A	;uloz vysledek
	MOV A,vvys
	RLC A
	MOV vvys,A
	RET


;----------------------------------------------------------

;Rutina "zpet" - opak rutiny uloz

zpet:	MOV vvys,schov_1
	MOV vys,schov_2
	MOV str,schov_3
	MOV niz,schov_4
	MOV nejniz,schov_5	
	RET
;----------------------------------------------------------

;Rutina hexadec. odecitani 3 byte cisla -----

odecet:	MOV A,str
	SUBB A,niz_1
	MOV str,A
	MOV A,vys	;nacti vyssi byte delence
	SUBB A,str_1	;odecti od nej stredni byte delitele
	MOV vys,A	;uloz vysledek
	MOV A,vvys	;nacti nejvyssi byte delence
	SUBB A,vys_1	;odecti od nej vyssi byte delitele
	MOV vvys,A	;uloz vysledek	
	RET
;-----------------------------------------------------------


